config/routes.rb
require 'sidekiq/web'

Rails.application.routes.draw do
  mount Sidekiq::Web => '/sidekiq'
  resources :sites
  resources :tags, only: [:show,:create]

  root to: 'sites#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/site.rb
class Site < ApplicationRecord
  has_many :tag, dependent: :destroy

  validates :url, presence: true, length: { minimum: 6 }
  validates :url, uniqueness: true
  validates :url, format: { with: URI.regexp }, allow_blank: true

end

app/models/tag.rb
class Tag < ApplicationRecord
  belongs_to :site
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/sites_controller.rb
class SitesController < ApplicationController
  before_action :set_site, only: [:show, :edit, :update, :destroy]
  skip_before_action :verify_authenticity_token, only: [:create]

  # GET /sites
  # GET /sites.json
  def index
    @sites = Site.includes(:tag).all.order(created_at: :desc).paginate(page: params[:page], per_page: 8)
  end

  # GET /sites/1
  # GET /sites/1.json
  def show
  end

  # GET /sites/new
  def new
    @site = Site.new
  end

  # GET /sites/1/edit
  def edit
  end

  # POST /sites
  # POST /sites.json
  def create
    url = params[:site][:url]

    WalkJob.perform_now(url)
    sub_sites = RouteService.new(url).walk
    sub_sites.each do |site|
      WalkJob.perform_later(url+site)
    end
    
    respond_to do |format|
      format.html { redirect_to root_path, notice: "The system is crawling the #{url} website" }
    end
  end

  # PATCH/PUT /sites/1
  # PATCH/PUT /sites/1.json
  def update
    respond_to do |format|
      if @site.update(site_params)
        format.html { redirect_to @site, notice: 'Site was successfully updated.' }
        format.json { render :show, status: :ok, location: @site }
      else
        format.html { render :edit }
        format.json { render json: @site.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /sites/1
  # DELETE /sites/1.json
  def destroy
    @site.destroy
    respond_to do |format|
      format.html { redirect_to sites_url, notice: 'Site was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
  # Use callbacks to share common setup or constraints between actions.
  def set_site
    @site = Site.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def site_params
    params.require(:site).permit(:url)
  end

    # def tag_params
    #   params.require(:tag).permit(:h1, :h2, :h3, :h4, :h5, :h6, :link, :site_id)
    # end
end

app/controllers/tags_controller.rb
class TagsController < ApplicationController
  before_action :set_tag, only: [:show, :edit, :update, :destroy]
  skip_before_action :verify_authenticity_token, only: [:create]

  # GET /tags
  # GET /tags.json
  def index
    @tags = Tag.all
  end

  # GET /tags/1
  # GET /tags/1.json
  def show
  end

  # GET /tags/new
  def new
    @tag = Tag.new
  end

  # GET /tags/1/edit
  def edit
  end

  # POST /tags
  # POST /tags.json
  def create
    @tag = Tag.new(tag_params)

    respond_to do |format|
      if @tag.save
        format.html { redirect_to @tag, notice: 'Tag was successfully created.' }
        format.json { render :show, status: :created, location: @tag }
      else
        format.html { render :new }
        format.json { render json: @tag.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tags/1
  # PATCH/PUT /tags/1.json
  def update
    respond_to do |format|
      if @tag.update(tag_params)
        format.html { redirect_to @tag, notice: 'Tag was successfully updated.' }
        format.json { render :show, status: :ok, location: @tag }
      else
        format.html { render :edit }
        format.json { render json: @tag.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tags/1
  # DELETE /tags/1.json
  def destroy
    @tag.destroy
    respond_to do |format|
      format.html { redirect_to tags_url, notice: 'Tag was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_tag
      @tag = Tag.includes(:site).find_by(:site_id =>params[:id])

    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def tag_params
      params.require(:tag).permit(:h1, :h2, :h3, :h4, :h5, :h6, :link, :site_id)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper

  def flash_class(level)
    case level
      when 'notice' then "alert alert-dismissible alert-info"
      when 'success' then "alert alert-dismissible alert-success"
      when 'error' then "alert alert-dismissible alert-danger"
      when 'alert' then "alert alert-dismissible alert-warning"
    end
  end

end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/sites_helper.rb
module SitesHelper
end

app/helpers/tags_helper.rb
module TagsHelper
  def clear_tags(tag)
    tag.split(',').join(",<br> ").gsub(/^\["+|\"]+$/, "").gsub('"', '').gsub('\n', '').gsub('\t', '').html_safe
  end
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="pt-BR">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <!--Let browser know website is optimized for mobile-->
  <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
  <%= csrf_meta_tags %>
  <title>ZAG crawler</title>

  <!-- CSS  -->
  <!-- Material Design fonts -->
  <link rel="stylesheet" type="text/css" href="//fonts.googleapis.com/css?family=Roboto:300,400,500,700">
  <link rel="stylesheet" type="text/css" href="//fonts.googleapis.com/icon?family=Material+Icons">
  <!-- Latest compiled and minified CSS -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

  <!-- Compiled and minified CSS -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-material-design/0.5.9/css/bootstrap-material-design.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-material-design/0.5.9/css/ripples.min.css">

  <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
</head>

<body>

<%= render 'layouts/partials/menu' %>

<div class="container">
  <div class="row">
    <div class="col-md-12">

      <%= render 'layouts/partials/flash' %>

      <%= yield %>

    </div>
  </div>
</div>

<%= render 'layouts/partials/footer' %>

<%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>

<!-- Latest compiled and minified JavaScript -->
<!-- Latest compiled and minified JavaScript -->
<script src="https://npmcdn.com/tether@1.2.4/dist/js/tether.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
<!-- Compiled and minified JavaScript -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-material-design/0.5.9/js/material.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-material-design/0.5.9/js/ripples.min.js"></script>
</body>
</html>

app/views/layouts/partials/_flash.html.erb
<% flash.each do |key, value| %>
    <div class="<%= flash_class(key) %>">
      <button type="button" class="close" data-dismiss="alert">&times;</button>
      <strong><%= value %></strong>
    </div>
<% end %>

app/views/layouts/partials/_footer.html.erb
<div class="navbar navbar-default footer">
  <div class="container-fluid">
    <div class="navbar-header">
      <p class="center-text"> 
        This system was developed as part of the hiring process for ZAG Back End Developer position.
      </p>
    </div>
  </div>
</div>

app/views/layouts/partials/_menu.html.erb
<div class="navbar navbar-default">
  <div class="container-fluid">
    <div class="navbar-header">
      <%= link_to('ZAG Web Crawler', root_path, class: "navbar-brand") %>
    </div>
    <div class="navbar-collapse collapse navbar-responsive-collapse">
    </div>
  </div>
</div>

app/views/sites/_form.html.erb
<%= form_for(site) do |f| %>
  <% if site.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(site.errors.count, "error") %> prohibited this site from being saved:</h2>

      <ul>
      <% site.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :url %>
    <%= f.text_field :url,class: 'form-control' %>
  </div>

  <div class="actions">
    <%= f.submit "Criar", class: 'btn btn-raised btn-success' %>
  </div>
<% end %>

app/views/sites/edit.html.erb
<h1><%=t('sites.edit')%></h1>

<%= render 'form', site: @site %>

<%= link_to t('show'), @site, class: "btn btn-raised btn-primary" %> |
<%= link_to t('back'), sites_path, class: "btn btn-raised btn-default" %>

app/views/sites/index.html.erb
<%= form_tag({controller: "sites", action: "create"}, method: "post") do %>
    <div class="field">
      <input type="hidden" id="site_url" name="site[url]" value="https://elixir-lang.org/">
    </div>
    <div class="actions">
      <input type="submit" name="commit" value="Elixir Crawler" class="btn btn-raised btn-success" data-disable-with="Criar" />
      <%= link_to t('home.new'), new_site_path, class: 'btn btn-raised btn-success' %>
    </div>
<% end %>


<table class="table table-bordered table-striped">
  <thead>
  <tr>
    <th>Url</th>
    <th colspan="4"><%= t('action') %></th>
  </tr>
  </thead>

  <tbody>
  <% @sites.each do |site| %>
      <tr>
        <td><%= site.url %></td>
        <td><%= link_to t('home.show_content_url'), tag_path(site), class: 'btn btn-raised btn-info' %></td>
        <td><%= link_to t('show'), site, class: 'btn btn-raised btn-warning' %></td>
        <td><%= link_to t('edit'), edit_site_path(site), class: 'btn btn-raised btn-primary' %></td>
        <td><%= link_to "Delete", site, :confirm => "Are you sure?", :method => :delete, class: 'btn btn-raised btn-danger' %>
      </tr>
  <% end %>
  </tbody>
</table>
<%= will_paginate @sites %>

<br>

app/views/sites/new.html.erb
<h1><%=t('sites.new')%></h1>

<%= render 'form', site: @site %>

<%= link_to t('back'), sites_path, class: 'btn btn-raised btn-default' %>

app/views/sites/show.html.erb
<p>
  <strong>Url:</strong>
  <%= @site.url %>
</p>

<%= link_to t('edit'), edit_site_path(@site), class: "btn btn-raised btn-primary" %> |
<%= link_to t('back'), sites_path, class: "btn btn-raised btn-default" %>

app/views/tags/_form.html.erb
<%= form_for(tag) do |f| %>
  <% if tag.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(tag.errors.count, "error") %> prohibited this tag from being saved:</h2>

      <ul>
      <% tag.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :h1 %>
    <%= f.text_area :h1 %>
  </div>

  <div class="field">
    <%= f.label :h2 %>
    <%= f.text_area :h2 %>
  </div>

  <div class="field">
    <%= f.label :h3 %>
    <%= f.text_area :h3 %>
  </div>

  <div class="field">
    <%= f.label :h4 %>
    <%= f.text_area :h4 %>
  </div>

  <div class="field">
    <%= f.label :h5 %>
    <%= f.text_area :h5 %>
  </div>

  <div class="field">
    <%= f.label :h6 %>
    <%= f.text_area :h6 %>
  </div>

  <div class="field">
    <%= f.label :link %>
    <%= f.text_area :link %>
  </div>

  <div class="field">
    <%= f.label :site_id %>
    <%= f.text_field :site_id %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/tags/edit.html.erb
<h1>Editing Tag</h1>

<%= render 'form', tag: @tag %>

<%= link_to 'Show', @tag %> |
<%= link_to 'Back', tags_path %>

app/views/tags/index.html.erb
<h1>Tags</h1>

<table class="table table-bordered table-striped">
  <thead>
  <tr>
    <th>H1</th>
    <th>H2</th>
    <th>H3</th>
    <th>H4</th>
    <th>H5</th>
    <th>H6</th>
    <th>Link</th>
    <th>Site</th>
    <th colspan="3"></th>
  </tr>
  </thead>

  <tbody>
  <% @tags.each do |tag| %>
      <tr>
        <td><%= truncate(tag.h1, :length => 100) %></td>
        <td><%= truncate(tag.h2, :length => 100) %></td>
        <td><%= truncate(tag.h3, :length => 100) %></td>
        <td><%= truncate(tag.h4, :length => 100) %></td>
        <td><%= truncate(tag.h5, :length => 100) %></td>
        <td><%= truncate(tag.h6, :length => 100) %></td>
        <td><%= truncate(tag.link, :length => 100) %></td>
        <td><%= truncate(tag.image, :length => 100) %></td>
        <td><%= tag.site %></td>
        <td><%= link_to 'Show', tag %></td>
        <td><%= link_to 'Edit', edit_tag_path(tag) %></td>
        <td><%= link_to 'Destroy', tag, method: :delete, data: {confirm: 'Are you sure?'} %></td>
      </tr>
  <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Tag', new_tag_path %>

app/views/tags/new.html.erb
<h1>New Tag</h1>

<%= render 'form', tag: @tag %>

<%= link_to 'Back', tags_path %>

app/views/tags/show.html.erb
<p>
  <strong>H1:</strong>
  <%= clear_tags(@tag.h1) %>
</p>

<p>
  <strong>H2:</strong>
  <%= clear_tags(@tag.h2) %>
</p>

<p>
  <strong>H3:</strong>
  <%= clear_tags(@tag.h3) %>
</p>

<p>
  <strong>H4:</strong>
  <%= clear_tags(@tag.h4) %>
</p>

<p>
  <strong>H5:</strong>
  <%= clear_tags(@tag.h5) %>
</p>

<p>
  <strong>H6:</strong>
  <%= clear_tags(@tag.h6) %>
</p>

<p>
  <strong>Link:</strong>
  <%= clear_tags(@tag.link) %>
</p>

<p>
  <strong>Image:</strong>
  <%= clear_tags(@tag.image) %>
</p>

<p>
  <strong>Site:</strong>
  <%= @tag.site.url %>
</p>

<%#link_to 'Edit', edit_tag_path(@tag) %>
<%# link_to 'Back', tags_path %>
<%= link_to t('back'), sites_path, class: "btn btn-raised btn-default" %>